## visad
Interface SetIface

All Superinterfaces:
  Data, Thing

All Known Subinterfaces:
  Gridded1DSetIface, GriddedSetIface, SampledSetIface, SimpleSetIface

All Known Implementing Classes:
  Gridded1DSet, GriddedSet, SampledSet, Set, SimpleSet

public interface SetIface
extends Data

Interface to the abstract superclass of the VisAD hierarchy of sets.

Sets are subsets of R^n for n>0.

Field Summary

Fields inherited from interface visad.Data

`ABS, ACOS, ACOS_DEGREES, ADD, ASIN, ASIN_DEGREES, ATAN, ATAN_DEGREES, ATAN2, ATAN2_DEGREES, CEIL, COS, COS_DEGREES, DEGREES_TO_RADIANS, DEPENDENT, DIVIDE, EXP, FLOOR, INDEPENDENT, INV_ATAN2, INV_ATAN2_DEGREES, INV_DIVIDE, INV_POW, INV_REMAINDER, INV_SUBTRACT, LOG, MAX, MIN, MULTIPLY, NEAREST_NEIGHBOR, NEGATE, NO_ERRORS, NOP, POW, RADIANS_TO_DEGREES, REMAINDER, RINT, ROUND, SIN, SIN_DEGREES, SQRT, SUBTRACT, TAN, TAN_DEGREES, WEIGHTED_AVERAGE`

Method Summary
`Object` `cloneButType(MathType type)` Clones this set -- changing the MathType.
`void` `cram_missing(boolean[] range_select)`
`int[]` `doubleToIndex(double[][] value)`
`boolean` `equals(Object set)`
`boolean` `equalUnitAndCS(Set set)`
`CoordinateSystem` `getCoordinateSystem()` Returns the coordinate system transformation of the set.
`int` `getDimension()` Returns the rank of the samples in the set.
`double[][]` `getDoubles()` Returns an enumeration of the samples of the set in index order.
`double[][]` `getDoubles(boolean copy)` Returns an enumeration of the samples of the set in index order.
`int` `getLength()` Returns the number of samples in the set.
`int` `getManifoldDimension()` Returns the rank of the manifold of the set.
`int[][]` `getNeighbors(int dimension)`
`void` `getNeighbors(int[][] neighbors)`
`void` `getNeighbors(int[][] neighbors, float[][] weights)`
`float[][]` `getSamples()` Returns an enumeration of the samples of the set in index order.
`float[][]` `getSamples(boolean copy)` Returns an enumeration of the samples of the set in index order.
`ErrorEstimate[]` `getSetErrors()` Returns the error estimates of the samples in the set.
`Unit[]` `getSetUnits()` Returns the units of the samples in the set.
`int[]` `getWedge()` Returns a zig-zagging enumeration of sample indices with good coherence.
`double[][]` `indexToDouble(int[] index)`
`float[][]` `indexToValue(int[] index)` Returns the samples of the set corresponding to an array of 1-D indices.
`VisADGeometryArray` `make1DGeometry(byte[][] color_values)`
`VisADGeometryArray` `make2DGeometry(byte[][] color_values, boolean indexed)`
`VisADGeometryArray[]` `make3DGeometry(byte[][] color_values)`
`VisADGeometryArray[][]` `makeIsoLines(float[] intervals, float lowlimit, float highlimit, float base, float[] fieldValues, byte[][] color_values, boolean[] swap, boolean dash, boolean fill, ScalarMap[] smap, double scale_ratio, double label_size, float[][][] f_array)`
`VisADGeometryArray` `makeIsoSurface(float isolevel, float[] fieldValues, byte[][] color_values, boolean indexed)`
`VisADGeometryArray` `makePointGeometry(byte[][] color_values)`
`Set` `makeSpatial(SetType type, float[][] values)`
`Set` `merge1DSets(Set set)`
`int[]` `valueToIndex(float[][] value)` Returns the 1-D indices corresponding to an array of points.

Methods inherited from interface visad.Data

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, adjustSamplingError, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, computeRanges, computeRanges, computeRanges, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, getType, isMissing, local, log, log, longString, longString, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, unary, unary`

Methods inherited from interface visad.Thing
`addReference, removeReference`

Method Detail

### getSetUnits

    public Unit[] getSetUnits()

  Returns the units of the samples in the set.

  Returns:
    The units of the samples in the set. Element [i] is the unit of the i-th coordinate.

### getSetErrors

    public ErrorEstimate[] getSetErrors()

  Returns the error estimates of the samples in the set.

  Returns:
    The error estimates of the samples in the set. Element [i] is the error estimate of the i-th coordinate.

### getCoordinateSystem

    public CoordinateSystem getCoordinateSystem()

  Returns the coordinate system transformation of the set.

  Returns:
    The coordinate system transformation of the set.

### getDimension

    public int getDimension()

  Returns the rank of the samples in the set.

  Returns:
    The rank of the samples in the set.

### getManifoldDimension

    public int getManifoldDimension()

  Returns the rank of the manifold of the set.

  Returns:
    The rank of the manifold of the set.

### getLength

    public int getLength()
                  throws VisADException

  Returns the number of samples in the set.

  Returns:
    The number of samples in the set.
  Throws:
    `VisADException`

### indexToValue

    public float[][] indexToValue(int[] index)
                           throws VisADException

  Returns the samples of the set corresponding to an array of 1-D indices.

  Parameters:
    `index` - The array of 1-D indices.
  Returns:
    The values of the set corresponding to the input indices. Element [i][j] is the i-th coordinate of the sample at index `index[j]`.
  Throws:
    `VisADException` - VisAD failure.

### valueToIndex

    public int[] valueToIndex(float[][] value)
                       throws VisADException

  Returns the 1-D indices corresponding to an array of points. The set must have at least two samples.

  Parameters:
    `value` - An array of points. `value[i][j]` is the i-th coordinate of the j-th point.
  Returns:
    Indices of the nearest samples in the set. If the j-th point lies within the set, then element [i] is the index of the closest sample; otherwise, element [i] is -1.
  Throws:
    `VisADException` - VisAD failure.

### makeSpatial

    public Set makeSpatial(SetType type,
                           float[][] values)
                    throws VisADException

  Throws:
    `VisADException`

### getWedge

    public int[] getWedge()

  Returns a zig-zagging enumeration of sample indices with good coherence.

  Returns:
    Indices of the samples of the set in a zig- zagging pattern with good coherence.

### getSamples

    public float[][] getSamples()
                         throws VisADException

  Returns an enumeration of the samples of the set in index order. This is the same as `getSamples(true)`.

  Returns:
    An enumeration of the samples of the set. Element [i][j] is the i-th coordinate of the j-th sample.
  Throws:
    `VisADException` - VisAD failure.
  See Also:
    `getSamples(boolean copy)`

### getSamples

    public float[][] getSamples(boolean copy)
                         throws VisADException

  Returns an enumeration of the samples of the set in index order.

  Parameters:
    `copy` - Whether or not to make a copy of the samples of the set.
  Returns:
    An enumeration of the samples of the set. Element [i][j] is the i-th coordinate of the j-th sample.
  Throws:
    `VisADException` - VisAD failure.

### getDoubles

    public double[][] getDoubles()
                          throws VisADException

  Returns an enumeration of the samples of the set in index order. This is the same as `getDoubles(true)`.

  Returns:
    An enumeration of the samples of the set. Element [i][j] is the i-th coordinate of the j-th sample.
  Throws:
    `VisADException` - VisAD failure.
  See Also:
    `getDoubles(boolean copy)`

### getDoubles

    public double[][] getDoubles(boolean copy)
                          throws VisADException

  Returns an enumeration of the samples of the set in index order.

  Parameters:
    `copy` - Whether or not to make a copy of the samples of the set.
  Returns:
    An enumeration of the samples of the set. Element [i][j] is the i-th coordinate of the j-th sample.
  Throws:
    `VisADException` - VisAD failure.

### cram_missing

    public void cram_missing(boolean[] range_select)

### merge1DSets

    public Set merge1DSets(Set set)
                    throws VisADException

  Throws:
    `VisADException`

### make1DGeometry

    public VisADGeometryArray make1DGeometry(byte[][] color_values)
                                      throws VisADException

  Throws:
    `VisADException`

### make2DGeometry

    public VisADGeometryArray make2DGeometry(byte[][] color_values,
                                             boolean indexed)
                                      throws VisADException

  Throws:
    `VisADException`

### make3DGeometry

    public VisADGeometryArray[] make3DGeometry(byte[][] color_values)
                                        throws VisADException

  Throws:
    `VisADException`

### makePointGeometry

    public VisADGeometryArray makePointGeometry(byte[][] color_values)
                                         throws VisADException

  Throws:
    `VisADException`

### makeIsoLines

    public VisADGeometryArray[][] makeIsoLines(float[] intervals,
                                               float lowlimit,
                                               float highlimit,
                                               float base,
                                               float[] fieldValues,
                                               byte[][] color_values,
                                               boolean[] swap,
                                               boolean dash,
                                               boolean fill,
                                               ScalarMap[] smap,
                                               double scale_ratio,
                                               double label_size,
                                               float[][][] f_array)
                                        throws VisADException

  Throws:
    `VisADException`

### makeIsoSurface

    public VisADGeometryArray makeIsoSurface(float isolevel,
                                             float[] fieldValues,
                                             byte[][] color_values,
                                             boolean indexed)
                                      throws VisADException

  Throws:
    `VisADException`

### indexToDouble

    public double[][] indexToDouble(int[] index)
                             throws VisADException

  Throws:
    `VisADException`

### doubleToIndex

    public int[] doubleToIndex(double[][] value)
                        throws VisADException

  Throws:
    `VisADException`

### getNeighbors

    public void getNeighbors(int[][] neighbors)
                      throws VisADException

  Throws:
    `VisADException`

### getNeighbors

    public void getNeighbors(int[][] neighbors,
                             float[][] weights)
                      throws VisADException

  Throws:
    `VisADException`

### getNeighbors

    public int[][] getNeighbors(int dimension)
                         throws VisADException

  Throws:
    `VisADException`

### equalUnitAndCS

    public boolean equalUnitAndCS(Set set)

### equals

    public boolean equals(Object set)

### cloneButType

    public Object cloneButType(MathType type)
                        throws VisADException

  Clones this set -- changing the MathType.

  Parameters:
    `type` - The MathType for the clone.
  Returns:
    A clone of this set with the new MathType.
  Throws:
    `VisADException` - VisAD failure.